=== debian/changelog ===
intel-cmt-cat (0.1.4-1) unstable; urgency=medium

  * Sync with upstream 0.1.4

 -- Colin King <colin.king@canonical.com>  Mon, 15 Feb 2016 11:16:12 +0000

intel-cmt-cat (0.1.3-2) unstable; urgency=medium

  * Add more Xeon CPU information in description. (Closes: #805458)
    - with thanks to Stephen Kitt for feedback on this.

 -- Colin King <colin.king@canonical.com>  Wed, 18 Nov 2015 11:38:00 +0000

intel-cmt-cat (0.1.3-1) unstable; urgency=medium

  * Initial Debian Release (Closes: #804700)

 -- Colin King <colin.king@canonucal.com>  Tue, 10 Nov 2015 13:26:00 +0000
