=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_HARDENING=1
export PREFIX=/usr/sbin

override_dh_install:
	mkdir -p $$(pwd)/debian/intel-cmt-cat/usr/share/man/man8 
	gzip --best < pqos.8 > $$(pwd)/debian/intel-cmt-cat/usr/share/man/man8/pqos.8.gz
	dh_install

%:
	dh $@
