=== debian/changelog ===
intel-cmt-cat (0.1.5-2) unstable; urgency=medium

  * Enable building of shared library (Closes: #840349)
  * Update hardening flags

 -- Colin King <colin.king@canonical.com>  Tue, 11 Oct 2016 10:59:31 +0100

intel-cmt-cat (0.1.5-1) unstable; urgency=medium

  * Sync with upstream 0.1.5
  * Update debian/control Standards-Version to 3.9.8

 -- Colin King <colin.king@canonical.com>  Thu, 6 Oct 2016 10:58:01 +0100
