=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Uploaders: Kamal Mostafa <kamal@whence.com>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9)
 Homepage: https://github.com/01org/intel-cmt-cat
 
@@ -15,4 +15,3 @@
  Cache Monitoring Technology (CMT), Memory Bandwidth Monitoring (MBM) and
  Cache Allocation Technology (CAT) features on modern Intel (R) Xeon (R)
  processors: Xeon D, Xeon E5 v3, Xeon E3 v4, or later models.
-
