## intel-cmt-cat 0.1.5.1

=== debian/changelog ===
intel-cmt-cat (0.1.5.1-1) unstable; urgency=medium

  * Sync with upstream 0.1.5.1
    (commit 8602f89d59804222593df49bc44c23f4bf786268)
 
 -- Colin King <colin.king@canonical.com>  Tue, 14 Feb 2017 12:53:11 +0000
